/* =v============ INIT ============v= */
// These functions are run at the loading of a page
window.onload = function () {
	
		generateMobinav();
		createToggleableContent();
	
}
/* =^==============================^= */

/* =v=========== MOBINAV ==========v= */
// This function generates a small collection of quick links that are
// constructed based on the document headings and links contained
// in the navigation.

// Set the default Mobinav state to off
var mobinavState = "off";

/* -v------- Fetch Headings -------v- */
// This function fetches multiple elements and returns them in an
// array.
function getElementsByTagNames(list,obj) {
	if (!obj) var obj = document;
	var tagNames = list.split(',');
	var resultArray = new Array();
	for (var i=0;i<tagNames.length;i++) {
		var tags = obj.getElementsByTagName(tagNames[i]);
		for (var j=0;j<tags.length;j++) {
			resultArray.push(tags[j]);
		}
	}
	var testNode = resultArray[0];
	if (!testNode) return [];
	if (testNode.sourceIndex) {
		resultArray.sort(function (a,b) {
				return a.sourceIndex - b.sourceIndex;
		});
	}
	else if (testNode.compareDocumentPosition) {
		resultArray.sort(function (a,b) {
				return 3 - (a.compareDocumentPosition(b) & 6);
		});
	}
	return resultArray;
}
/* -^------------------------------^- */

/* -v------ Generate Mobinav ------v- */
// This function generates the mobinav icon and link and places it into the document
function generateMobinav() {
	if(document.getElementById && document.getElementsByName) {
		// Create the container div for all elements inside the Mobinav
		var mobinav = document.createElement('div');
		mobinav.id = 'mobinav';
		// Create the Mobinav icon and link
		var mobinavLink = document.createElement('a');
		mobinavLink.href = "#";
		mobinavLink.onclick = toggleMobinav;
		mobinavLink.innerHTML = "Naviagate";
		mobinavLink.style.margin = "0 0 0 1px";
		mobinavLink.id = "mobinavToggleLink";
		mobinav.appendChild(mobinavLink);
		// Create the containing div
		var base = document.createElement('div');
		base.id = "mobinavContent";
		var headings = getElementsByTagNames('h2,h3,h4,h5');
		// Generate quick links based on navigation
		var links = document.getElementById('navigation').getElementsByTagName('a');
		var linkList = document.createElement('ol');
		linkList.className = "navList";
		// Go through the navigation links and generate corresponding links
		for(i = 0; i < links.length; i++) {
			var linkEntry = document.createElement('li');
			linkEntry.className = "navLink";
			var link = document.createElement('a');
			link.innerHTML = links[i].innerHTML;
			link.href = links[i].href;
			linkEntry.appendChild(link);
			linkList.appendChild(linkEntry);
		}	
		// Generate table of contents based on document headings

		var linkList2 = document.createElement('ol');
		linkList2.className = "mobinavList";
		// Go through the headings and generate corresponding links
		for(i = 0; i < headings.length; i++) {
				var linkEntry = document.createElement('li');
				linkEntry.className = "mobinavLink";
				var link = document.createElement('a');
				link.innerHTML = headings[i].innerHTML;
				linkEntry.appendChild(link);
				linkList2.appendChild(linkEntry);
			var headerId = headings[i].id || 'link' + i;
			link.href = '#' + headerId;
			link.onclick = toggleMobinav;
			headings[i].id = headerId;
		}
		// Append the link lists to the containing div
		base.appendChild(linkList);
		base.appendChild(linkList2);
		mobinav.appendChild(base);
		// Append the containing div to body
		document.getElementsByTagName('body')[0].appendChild(mobinav);
	}
}
/* -^------------------------------^- */

/* -v------- Toggle Mobinav -------v- */
// This function shows and hides the mobinav icon and link based on the state
function toggleMobinav() {
	if(mobinavState == "on") {
		document.getElementById("mobinavContent").style.display = "none";
		mobinavState = "off";
	} else {
		document.getElementById("mobinavContent").style.display = "block";
		mobinavState = "on";
	}
}


